# simple-i3blocks
![demo0](https://will.kein.hk/git/koksnuss/simple-i3blocks/raw/master/demo-full-0.png)

![demo1](https://will.kein.hk/git/koksnuss/simple-i3blocks/raw/master/demo-full-1.png)

This is a simple collection of i3blocks-modules accompagnied by a config file with the aim to display only important information in favor of not spilling lots of numbers into the status bar. 

# Usage
- module *datetime*: A left click will toggle long and short displays. The short version is displayed in the format `HH:MM`. The long version also shows the day of the week, weeknumber, date and seconds.
- module *audio*: `instance=mic` will show the microphone level instead. With a left mouse click the device is muted/unmuted.
- module *ram*: by default free ram and swap are shown in the format `a+b G` where `a` is ram and `b` is swap. If you want to show ram and swap seperatly, use `instance=ram` or `instance=swap`. If you left click on the block, `top` will be openend.
- *cpu*: by default total idle cpu time of all cores together is displayed. If you left click on the block, `top` will be openend.
- module *battery*: By default the total energy left of all batteries is shown. Use `instance=x` to show the status of `BATx` in case you have more than one battery in `/sys/class/powersupply`.
- module *backlight*: By default the brightness level is shown in the default font color (depending on your i3 config). Use `instance="color"` to print the brightness level colored which is nice when using a device in battery mode.

# Requirements
Install [i3 window manager](https://i3wm.org) alongside with [i3blocks](https://github.com/vivien/i3blocks) and `git`. The following shows the requirements for each module:
```
module      dependency
--------------------------
audio       amixer
battery     none, searches in /sys/class/power_supply/BAT...
cpu         top, htop for click support
datetime    date
ip          curl
ram         none, searches in /proc/meminfo, htop for click support
storage     df
backlight   none, searches in /sys/class/backlight, intel and ati/amd supported
```

# Install
One-Liner: Open up a terminal and paste: `bash <(curl -s https://will.kein.hk/git/koksnuss/simple-i3blocks/raw/master/install.sh)`

- Backup: `mv ~/.config/i3blocks{,.bak}`
- Clone: `git clone https://will.kein.hk/git/koksnuss/simple-i3blocks.git ~/.config/i3blocks`
- Adjust `~/.config/i3blocks/config` to control i3 status bar output (see [Usage](#usage)).
- Make sure you've added `bar { status_command i3blocks }` in your i3-config file (i.e. `~/config/i3/config`).
- Finally reload your `i3` window manager. The default shortcut is `mod + SHIFT + r`, you should see a flickering.


# Roadmap

## Modules
- [x] datetime
- [x] ram/swap
- [x] cpu
- [x] audio/mic
- [x] storage
- [x] ip
- [x] battery
- [x] backlight
- [ ] wifi/ethernet/bluetooth
- [ ] external storage 
- [ ] ethernet bandwith

## Click interactions
- [x] datetime: left: show weekday, date, weeknumber and seconds
- [x] audio/mic: left: toggle mute
- [x] ram/cpu: left: open `top` in a terminal
- [ ] external storage: mount it somewhere

## Signals
- [ ] audio, mic
- [ ] backlight

## Other
- [x] nice icons as labels
